Package edu.wisc.game.parser

## Class Expression.SerialExpression

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - java.util.AbstractList<E>
    - - java.util.Vector<Expression.ArithmeticExpression>
      - - edu.wisc.game.parser.Expression.SerialExpression

- All Implemented Interfaces:
    `Expression`, `Expression.ArithmeticExpression`, `Serializable`, `Cloneable`, `Iterable<Expression.ArithmeticExpression>`, `Collection<Expression.ArithmeticExpression>`, `List<Expression.ArithmeticExpression>`, `RandomAccess`
  Direct Known Subclasses:
    `Expression.AdditiveExpression`, `Expression.EqualityExpression`, `Expression.MultiplicativeExpression`
  Enclosing interface:
    Expression

      public abstract static class Expression.SerialExpression
      extends Vector<Expression.ArithmeticExpression>
      implements Expression.ArithmeticExpression

  Additive or multiplicative
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface edu.wisc.game.parser.Expression

      `Expression.AdditiveExpression, Expression.ArithmeticExpression, Expression.BracketList, Expression.ColonExpression, Expression.EqualityExpression, Expression.ExList, Expression.Id, Expression.MultiplicativeExpression, Expression.NegationExpression, Expression.Num, Expression.ParenList, Expression.QualifiedId, Expression.RangeExpression, Expression.SerialExpression, Expression.Star`

  - ### Field Summary

    - ### Fields inherited from class java.util.Vector

      `capacityIncrement, elementCount, elementData`

    - ### Fields inherited from class java.util.AbstractList

      `modCount`

    - ### Fields inherited from interface edu.wisc.game.parser.Expression

      `STAR`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SerialExpression()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HashSet<Integer>` | `evalSet​(HashMap<String,​HashSet<Integer>> hh)` | Evaluates this expression for the given values of the variables involved.
    `HashSet<String>` | `listAllVars()` | Lists all variable names used in this expression
    `String` | `toSrc()` |
    `String` | `toString()` |

    - ### Methods inherited from class java.util.Vector

      `add, add, addAll, addAll, addElement, capacity, clear, clone, contains, containsAll, copyInto, elementAt, elements, ensureCapacity, equals, firstElement, forEach, get, hashCode, indexOf, indexOf, insertElementAt, isEmpty, iterator, lastElement, lastIndexOf, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, removeAllElements, removeElement, removeElementAt, removeIf, removeRange, replaceAll, retainAll, set, setElementAt, setSize, size, sort, spliterator, subList, toArray, toArray, trimToSize`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, stream, toArray`

- - ### Constructor Detail

    - #### SerialExpression

          public SerialExpression()

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Vector<Expression.ArithmeticExpression>`

    - #### toSrc

          public String toSrc()

      Specified by:
        `toSrc` in interface `Expression`

    - #### listAllVars

          public HashSet<String> listAllVars()

      Lists all variable names used in this expression
      Specified by:
        `listAllVars` in interface `Expression.ArithmeticExpression`

    - #### evalSet

          public HashSet<Integer> evalSet​(HashMap<String,​HashSet<Integer>> hh)

      Description copied from interface: `Expression.ArithmeticExpression`
      Evaluates this expression for the given values of the variables involved. Can be used when the arguments can have multiple values.
      Specified by:
        `evalSet` in interface `Expression.ArithmeticExpression`
      Parameters:
        `hh` - The hash map that contains for each variable the possible set of its values.
      Returns:
        the set of the possible values of the expression, or an empty set if the expression uses a variable whose value is not in h